﻿using System.Drawing;

using DevExpress.XtraEditors;
using DevExpress.XtraMap;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 맵 다각형 1을 설정한다.

            MapPolygon mapPolygon1 = new MapPolygon();

            mapPolygon1.Fill = Color.RoyalBlue;

            mapPolygon1.Points.Add(new GeoPoint( 10, -170));
            mapPolygon1.Points.Add(new GeoPoint( 10,  170));
            mapPolygon1.Points.Add(new GeoPoint(-10,  170));
            mapPolygon1.Points.Add(new GeoPoint(-10, -170));

            this.mapItemStorage.Items.Add(mapPolygon1);

            #endregion
            #region 맵 다각형 2를 설정한다.

            MapPolygon mapPolygon2 = new MapPolygon();

            mapPolygon2.Fill = Color.Orange;

            mapPolygon2.Points.Add(new GeoPoint(30, 190));
            mapPolygon2.Points.Add(new GeoPoint(30, 170));
            mapPolygon2.Points.Add(new GeoPoint(20, 170));
            mapPolygon2.Points.Add(new GeoPoint(20, 190));

            this.mapItemStorage.Items.Add(mapPolygon2);

            #endregion
            #region 지리 맵 좌표계를 설정한다.

            GeoMapCoordinateSystem geoMapCoordinateSystem = new GeoMapCoordinateSystem();

            geoMapCoordinateSystem.CircularScrollingMode = CircularScrollingMode.TilesAndVectorItems;

            this.mapControl.CoordinateSystem = geoMapCoordinateSystem;

            #endregion
            #region 이벤트를 설정한다.

            this.openStreetMapDataProvider.WebRequest += openStreetMapDataProvider_WebRequest;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region OPEN STREET MAP 데이터 공급자 웹 요청시 처리하기 - openStreetMapDataProvider_WebRequest(sender, e)

        /// <summary>
        /// OPEN STREET MAP 데이터 공급자 웹 요청시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void openStreetMapDataProvider_WebRequest(object sender, MapWebRequestEventArgs e)
        {
            e.UserAgent = "XtraMap Getting Started - Connect to OpenStreetMap";
        }

        #endregion
    }
}